Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.security
Class KeyPairGeneratorSpi

    java.lang.Object
      |
      +--java.security.KeyPairGeneratorSpi

Direct Known Subclasses:
  KeyPairGenerator

public abstract class KeyPairGeneratorSpi
extends Object

This class defines the Service Provider Interface (SPI) for the `KeyPairGenerator` class, which is used to generate pairs of public and private keys.

All the abstract methods in this class must be implemented by each cryptographic service provider who wishes to supply the implementation of a key pair generator for a particular algorithm.

In case the client does not explicitly initialize the KeyPairGenerator (via a call to an `initialize` method), each provider must supply (and document) a default initialization. For example, the Sun provider uses a default modulus size (keysize) of 1024 bits.

See Also:
  `KeyPairGenerator`, `AlgorithmParameterSpec`

Constructor Summary
`KeyPairGeneratorSpi()`

Method Summary
`abstract KeyPair` | `generateKeyPair()` Generates a key pair.
`void` | `initialize(AlgorithmParameterSpec params, SecureRandom random)` Initializes the key pair generator using the specified parameter set and user-provided source of randomness.
`abstract void` | `initialize(int keysize, SecureRandom random)` Initializes the key pair generator for a certain keysize, using the default parameter set.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### KeyPairGeneratorSpi

    public KeyPairGeneratorSpi()

Method Detail

### initialize

    public abstract void initialize(int keysize,
                                    SecureRandom random)

  Initializes the key pair generator for a certain keysize, using the default parameter set.
  Parameters:
    `keysize` - the keysize. This is an algorithm-specific metric, such as modulus length, specified in number of bits.
    `random` - the source of randomness for this generator.
  Throws:
    `InvalidParameterException` - if the `keysize` is not supported by this KeyPairGeneratorSpi object.

### initialize

    public void initialize(AlgorithmParameterSpec params,
                           SecureRandom random)
                    throws InvalidAlgorithmParameterException

  Initializes the key pair generator using the specified parameter set and user-provided source of randomness.

  This concrete method has been added to this previously-defined abstract class. (For backwards compatibility, it cannot be abstract.) It may be overridden by a provider to initialize the key pair generator. Such an override is expected to throw an InvalidAlgorithmParameterException if a parameter is inappropriate for this key pair generator. If this method is not overridden, it always throws an UnsupportedOperationException.

  Parameters:
    `params` - the parameter set used to generate the keys.
    `random` - the source of randomness for this generator.
  Throws:
    `InvalidAlgorithmParameterException` - if the given parameters are inappropriate for this key pair generator.
  Since:
    1.2

### generateKeyPair

    public abstract KeyPair generateKeyPair()

  Generates a key pair. Unless an initialization method is called using a KeyPairGenerator interface, algorithm-specific defaults will be used. This will generate a new key pair every time it is called.
  Returns:
    the newly generated `KeyPair`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2001 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.